/*---------------------------------------------------------------------------------------------------------------------------------------------------
 *
 * 20130504 2.3.6 TEST: FALSE statt TRUE
 *
 * IR in: 		A0 				(irmpconfig.h)
 * IR out: 		PD7
 *
 * Relais 1:	C2
 * Relais 2:	C4
 *
 * LED_B7:		IR senden
 * LED_B6:		GO Zhler luft
 * LED_B5:
 * LED_B4:
 * LED_B3:
 * LED_B2:
 * LED_B1:		Relais 1 an
 * LED_B0:		Relais 2 an
 
 *
 * main module
 *
 * ATMEGA32 @ 16 MHz
 *
 * ??????????? Fuses: lfuse: 0xFF hfuse: 0xCA efuse: 0xFF (kein Ausleseschutz)
 *
 *---------------------------------------------------------------------------------------------------------------------------------------------------
 */
#define F_CPU 			16000000UL
#define ATMEL_AVR
#define AVR_ATmega32
#define RC5_DTV			8		// Technisat HD8S = SAT 1

unsigned short Geraetetaste = 0;

#include <inttypes.h>
#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>

#include "irsnd.c"
#include "irmp.c"

// #include "irsnd.h"        	geht nur mit .c
// #include "irmp.h"		geht nur mit .c

/* TEST START Time 0
void
timer0_init (void)
{

	//Timer 0 init 
	TCNT0 = 0x00;   // Timer0 Counter to zero 
	//Timer Start
	TCCR0 = ( 1 << CS02 | 0 << CS01 | 1 << CS00 ) ; // Prescaler 1024 / Clock <- CPU 
	TIMSK = ( 1 << TOIE0 )   ;   // Timer0 ISR activate 

	OCR1A   =  (F_CPU / F_INTERRUPTS) - 1;                                    // compare value: 1/10000 of CPU frequency
	//OCR1A   =  0x577;                                    // compare value: 1/10000 of CPU frequency
}
*/

/*---------------------------------------------------------------------------------------------------------------------------------------------------
 * ATMEL AVR part:
 *---------------------------------------------------------------------------------------------------------------------------------------------------
 */
#if defined (ATMEL_AVR)

void
timer1_init (void)
{
#if defined (__AVR_ATtiny45__) || defined (__AVR_ATtiny85__)                // ATtiny45 / ATtiny85:

#if F_CPU >= 16000000L
    OCR1C   =  (F_CPU / F_INTERRUPTS / 8) - 1;                              // compare value: 1/15000 of CPU frequency, presc = 8
    TCCR1   = (1 << CTC1) | (1 << CS12);                                    // switch CTC Mode on, set prescaler to 8
#else
    OCR1C   =  (F_CPU / F_INTERRUPTS / 4) - 1;                              // compare value: 1/15000 of CPU frequency, presc = 4
    TCCR1   = (1 << CTC1) | (1 << CS11) | (1 << CS10);                      // switch CTC Mode on, set prescaler to 4
#endif

#else                                                                       // ATmegaXX:
    OCR1A   =  (F_CPU / F_INTERRUPTS) - 1;                                  // compare value: 1/15000 of CPU frequency
    TCCR1B  = (1 << WGM12) | (1 << CS10);                                   // switch CTC Mode on, set prescaler to 1
#endif

#ifdef TIMSK1
    TIMSK1  = 1 << OCIE1A;                                                  // OCIE1A: Interrupt by timer compare
#else
    TIMSK   = 1 << OCIE1A;                                                  // OCIE1A: Interrupt by timer compare
#endif
}

#ifdef TIM1_COMPA_vect                                                      // ATtiny84
#define COMPA_VECT  TIM1_COMPA_vect
#else
#define COMPA_VECT  TIMER1_COMPA_vect                                       // ATmega
#endif

/*-----------------------------------------------------------------------------------------------------------------------
 * LED_B0S definieren
 *-----------------------------------------------------------------------------------------------------------------------
 */

/* entfernt */


/*-----------------------------------------------------------------------------------------------------------------------
 * Initialize LED_B0s
 *-----------------------------------------------------------------------------------------------------------------------
 */

/* entfernt */


/*-----------------------------------------------------------------------------------------------------------------------
 * LED_B0 blinkt 50ms und setzt GO Bit zurck
 *-----------------------------------------------------------------------------------------------------------------------
 */
 
/* entfernt */


/*---------------------------------------------------------------------------------------------------------------------------------------------------
 * timer 1 compare handler, calLED_B0 every 1/10000 sec
 *---------------------------------------------------------------------------------------------------------------------------------------------------
 */

// MODIFIZIERT !!


#ifdef TIM1_COMPA_vect                                                      // ATtiny84
#define COMPA_VECT  TIM1_COMPA_vect
#else
#define COMPA_VECT  TIMER1_COMPA_vect                                       // ATmega
#endif

ISR(COMPA_VECT)                                                             // Timer1 output compare A interrupt service routine, calLED_B0 every 1/15000 sec
{
  if (! irsnd_ISR())          // call irsnd ISR
  {                           // if not busy...
      irmp_ISR();             // call irmp ISR
  }
  // call other timer interrupt routines...
}


/*---------------------------------------------------------------------------------------------------------------------------------------------------
 * MAIN: main routine
 *---------------------------------------------------------------------------------------------------------------------------------------------------
 */
int
main (void)
{
    LED_init ();

	IRMP_DATA irmp_data;
 
	irmp_init();                // initialize irmp
	irsnd_init();               // initialize irsnd
	timer1_init();              // initialize timer
	sei ();                     // enable interrupts
 
				
	for (;;)					// Start Endlos-Hauptschleife
	{
		if (irmp_get_data (&irmp_data))
		{	// ir signal decoded, do something here...
			
			if (irmp_data.protocol == IRMP_BANG_OLUFSEN_PROTOCOL) 		// Geraetetaste abfragen und zuweisen
			
			// tv = 1

				{
					switch (irmp_data.command)
					{
						case 0x80:   Geraetetaste = 1; break;			// Taste "TV"
					}

/*---------------------------------------------------------------------------------------------------------------------------------------------------
 * IR: Allgemeines fr Videobefehle
 *---------------------------------------------------------------------------------------------------------------------------------------------------
 */

/* Gerte-Check */	if (Geraetetaste == 1 || Geraetetaste == 2)
					{
						switch (irmp_data.command) 
						{
/* in: VOL+ */			case 0x60:   irmp_data.protocol = IRMP_SAMSUNG32_PROTOCOL; irmp_data.address = 1799; irmp_data.command = 63495; irmp_data.flags = 0; (void) irsnd_send_data (&irmp_data, FALSE); break; // out: VOL+, Samsung32
						default: break;
						}
					}
	
				}	
		}	
	}	
}

#endif